initDBtables
DROP TABLE jena_sys_stmt;;
CREATE TABLE jena_sys_stmt (
 Subj       ${a} NOT NULL,
 Prop       ${a} NOT NULL,
 Obj        ${a} NOT NULL,
 GraphID    INTEGER
) ;;
DROP TABLE jena_long_lit;;
CREATE TABLE jena_long_lit (
 ID      	INTEGER NOT NULL identity PRIMARY KEY,
 Head    	integer NOT NULL,
 ChkSum		INT,
 Tail    	LONG VARBINARY
) ;;
DROP TABLE jena_long_uri;;
CREATE TABLE jena_long_uri (
 ID      	INTEGER NOT NULL identity PRIMARY KEY,
 Head    	integer NOT NULL,
 ChkSum 	INT,
 Tail    	LONG VARBINARY
) ;;
DROP TABLE jena_prefix;;
CREATE TABLE jena_prefix (
 ID      	INTEGER NOT NULL identity PRIMARY KEY,
 Head    	integer NOT NULL,
 ChkSum		INT,
 Tail    	LONG VARBINARY
) ;;
DROP TABLE jena_graph;;
CREATE TABLE jena_graph (
 ID      INTEGER NOT NULL identity PRIMARY KEY,
 Name    LONG VARBINARY
) ;;

CREATE UNIQUE INDEX jena_XLIT ON jena_long_lit(Head, ChkSum);;
CREATE UNIQUE INDEX jena_XURI ON jena_long_uri(Head, ChkSum);;
CREATE UNIQUE INDEX jena_XBND ON jena_prefix(Head, ChkSum);;
CREATE INDEX jena_XSP ON jena_sys_stmt(Subj, Prop);;
CREATE INDEX jena_XO ON jena_sys_stmt(Obj);;

createStatementTable
CREATE TABLE ${a} (
 Subj       ${b} NOT NULL,
 Prop       ${b} NOT NULL,
 Obj        ${b} NOT NULL,
 GraphID    INTEGER
) ;;

CREATE INDEX ${a}XSP ON ${a}(Subj, Prop);;
CREATE INDEX ${a}XO ON ${a}(Obj);;
createReifStatementTable
CREATE TABLE ${a} (
 Subj       ${b},
 Prop       ${b},
 Obj        ${b},
 GraphID    INTEGER,
 Stmt       ${b} NOT NULL,
 HasType    CHAR(1) NOT NULL
) ;;

CREATE UNIQUE INDEX ${a}XSTMT ON ${a}(Stmt, HasType);;
CREATE INDEX ${a}XSP ON ${a}(Subj, Prop);;
CREATE INDEX ${a}XO ON ${a}(Obj);;

lockDatabase
DROP_TABLE ('${a}');;
CREATE TABLE ${a} (Dummy INTEGER);;

unlockDatabase
DROP TABLE ${a};;

initDBgenerators
dropTable
DROP TABLE ${a}

removeRowsFromTable
DELETE FROM ${a} WHERE (GraphID = ?)

insertGraph
INSERT INTO ${a} (Name) VALUES (?)

deleteGraph
Update ${a} SET NAME=null where ID = ?

deleteStatement
Delete FROM ${a} WHERE (Subj = ? AND Prop = ? AND Obj = ? AND GraphID = ?)

insertStatement
INSERT INTO ${a} (Subj, Prop, Obj, GraphID) VALUES (?, ?, ?, ?)

getRowCount
SELECT COUNT(*) FROM ${a} WHERE (GraphID = ?)

insertLongObject
INSERT INTO ${a} (Head, ChkSum, Tail) VALUES (?, ?, ?)

getInsertID
Select Last_Insert_ID()

getLongObject
SELECT HEAD, TAIL FROM ${a} WHERE ID = ?

getLongObjectID
SELECT ID FROM ${a} WHERE Head = ? and ChkSum is NULL

getLongObjectIDwithChkSum
SELECT ID FROM ${a} WHERE Head = ? and ChkSum = ?

selectStatement
SELECT S.Subj, S.Prop, S.Obj
FROM ${a} S WHERE S.GraphID = ?

selectStatementS
SELECT S.Subj, S.Prop, S.Obj
FROM ${a} S WHERE S.Subj = ? AND S.GraphID = ?

selectStatementSP
SELECT S.Subj, S.Prop, S.Obj
FROM ${a} S WHERE S.Subj = ? AND S.Prop = ? AND S.GraphID = ?




selectStatementSPO
SELECT S.Subj, S.Prop, S.Obj
FROM ${a} S WHERE S.Obj = ? AND S.Subj = ? AND S.Prop = ? AND S.GraphID = ?




selectStatementSO
SELECT S.Subj, S.Prop, S.Obj
FROM ${a} S WHERE S.Obj = ? AND S.Subj = ? AND S.GraphID = ?




selectStatementPO
SELECT S.Subj, S.Prop, S.Obj
FROM jena_sys_stmt S WHERE S.Obj = ? AND S.Prop = ? AND S.GraphID = ?




selectStatementO
SELECT S.Subj, S.Prop, S.Obj
FROM ${a} S WHERE S.Obj = ? AND S.GraphID = ?




selectStatementP
SELECT S.Subj, S.Prop, S.Obj
FROM ${a} S WHERE S.Prop = ? AND S.GraphID = ?



selectReified
SELECT S.Subj, S.Prop, S.Obj, S.Stmt, S.HasType
FROM ${a} S WHERE S.GraphID = ?



selectReifiedT
SELECT S.Subj, S.Prop, S.Obj, S.Stmt, S.HasType
FROM ${a} S WHERE HasType = ? AND S.GraphID = ?




selectReifiedN
SELECT S.Subj, S.Prop, S.Obj, S.Stmt, S.HasType
FROM ${a} S WHERE S.Stmt = ? AND S.GraphID = ?




selectReifiedNT
SELECT S.Subj, S.Prop, S.Obj, S.Stmt, S.HasType
FROM ${a} S WHERE S.Stmt = ? AND HasType = ? AND S.GraphID = ?



deleteReified
Delete FROM ${a} WHERE (Subj = ? AND Prop = ? AND Obj = ? AND GraphID = ?
AND Stmt = ? AND HasType = ?)




deleteReifiedS
Delete FROM ${a} WHERE (Subj = ? AND Prop is null AND Obj is null AND GraphID = ?
AND Stmt = ? AND HasType is null)




deleteReifiedP
Delete FROM ${a} WHERE (Subj is null AND Prop = ? AND Obj is null AND GraphID = ?
AND Stmt = ? AND HasType is null)




deleteReifiedO
Delete FROM ${a} WHERE (Subj is null AND Prop is null AND Obj = ? AND GraphID = ?
AND Stmt = ? AND HasType is null)




deleteReifiedT
Delete FROM ${a} WHERE (Subj is null AND Prop is null AND Obj is null AND GraphID = ?
AND Stmt = ? AND HasType = 'T')





insertReified
INSERT INTO ${a} (Subj, Prop, Obj, GraphID, Stmt, HasType) VALUES (?, ?, ?, ?, ?, ?)



updateReifiedS
UPDATE ${a} SET Subj=? WHERE Stmt = ? AND GraphID = ?



updateReifiedP
UPDATE ${a} SET Prop=? WHERE Stmt = ? AND GraphID = ?



updateReifiedO
UPDATE ${a} SET Obj=? WHERE Stmt = ? AND GraphID = ?



updateReifiedT
UPDATE ${a} SET HasType=? WHERE Stmt = ? AND GraphID = ?



selectReifiedNS
SELECT S.Subj, S.Prop, S.Obj, S.Stmt, S.HasType
FROM ${a} S WHERE S.Stmt = ? AND S.Subj = ? AND S.GraphID = ?



selectReifiedNP
SELECT S.Subj, S.Prop, S.Obj, S.Stmt, S.HasType
FROM ${a} S WHERE S.Stmt = ? AND S.Prop = ? AND S.GraphID = ?



selectReifiedNO
SELECT S.Subj, S.Prop, S.Obj, S.Stmt, S.HasType
FROM ${a} S WHERE S.Stmt = ? AND S.Obj = ? AND S.GraphID = ?




selectReifNodeSPOT
SELECT S.Stmt
FROM ${a} S WHERE S.Subj = ? AND S.Prop = ? and S.Obj = ? AND S.GraphID = ? AND S.HasType = 'T'




selectReifNodeT
SELECT S.Stmt
FROM ${a} S WHERE S.GraphID = ? AND S.HasType = 'T'




selectReifNode
SELECT DISTINCT S.Stmt
FROM ${a} S WHERE S.GraphID = ?




selectReifNodeN
SELECT DISTINCT S.Stmt
FROM ${a} S WHERE S.Stmt = ? AND S.GraphID = ?
